package l16_streams;

import java.util.List;

public class GamesTest {

	record BoardGame(String name, double rating, double price, int minPlayers, int maxPlayers) { }

	public static void main(String ... args) {
		List<BoardGame> games = List.of(
			new BoardGame("Terraforming Mars", 8.38, 123.49, 1, 5),
			new BoardGame("Codenames", 7.82, 64.95, 2, 8),
			new BoardGame("Puerto Rico", 8.07, 149.99, 2, 5),
			new BoardGame("Terra Mystica", 8.26, 252.99, 2, 5),
			new BoardGame("Scythe", 8.3, 314.95, 1, 5),
			new BoardGame("Power Grid", 7.92, 145, 2, 6),
			new BoardGame("7 Wonders Duel", 8.15, 109.95, 2, 2),
			new BoardGame("Dominion: Intrigue", 7.77, 159.95, 2, 4),
			new BoardGame("Patchwork", 7.77, 75, 2, 2),
			new BoardGame("The Castles of Burgundy", 8.12, 129.95, 2, 4)
		);
		printUsingLoop(games);
		System.out.println();
		printUsingStream(games);
	}

	private static void printUsingLoop(List<BoardGame> games) {
		for (BoardGame game : games) {
			if (game.maxPlayers() > 4) {
				if (game.rating() > 8) {
					if (game.price() < 150) {
						System.out.println(game.name().toUpperCase());
					}
				}
			}
		}
	}

	private static void printUsingStream(List<BoardGame> games) {
		games.stream()
			.filter(game -> game.maxPlayers() > 4)
			.filter(game -> game.rating() > 8)
			.filter(game -> game.price() < 150)
			.map(BoardGame::name)
			.map(String::toUpperCase)
//			.map(game -> game.name().toUpperCase())
			.forEach(System.out::println);
	}
}
