package l16_streams;

import java.util.IntSummaryStatistics;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;

public class Java8Streams {

	public static void main(String[] args) {

		long count;

		List<String> strings = List.of("one", "", "two", "three", "four", "", "five");
		System.out.println("List: " + strings);

		count = strings
			.stream()
			.filter(String::isEmpty)
			.count();
		System.out.println("Empty Strings: " + count);

		count = strings
			.stream()
			.filter(string -> string.length() == 3)
			.count();
		System.out.println("Strings of length 3: " + count);

		List<String> notEmpty = strings
			.stream()
			.filter(string -> !string.isEmpty())
			.toList();
		System.out.println("List of not empty strings: " + notEmpty);

		String mergedString = strings
			.stream()
			.filter(string -> !string.isEmpty())
			.collect(Collectors.joining(" + "));
		System.out.println("Merged String: " + mergedString);
		System.out.println();

		List<Integer> numbers = List.of(1, 2, 13, 4, 2, 15, 6, 17, 8, 19, 1, 11);
		List<Integer> squaresList = numbers
			.stream()
			.distinct()
			.map(i -> i * i)
			.sorted()
			.toList();
		System.out.println("Squares List: " + squaresList);
		System.out.println();

		IntSummaryStatistics statistics = numbers
			.stream()
			.mapToInt(i -> i)
			.summaryStatistics();
		System.out.println("Highest number in List : " + statistics.getMax());
		System.out.println("Lowest number in List : " + statistics.getMin());
		System.out.println("Sum of all numbers : " + statistics.getSum());
		System.out.println("Average of all numbers : " + statistics.getAverage());
		System.out.println();

		System.out.println("Random Numbers: ");
		int sum = new Random()
			.ints()
			.limit(5)
			.map(n -> n % 100)
			.sorted()
			.peek(System.out::println) // returns void, pass elements through the stream
			.sum();
//			.forEach(System.out::println);
		System.out.println("sum = " + sum);
	}
}

