package l16_streams;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class StreamIterate {
	public static void main(String[] args) {

		List<Integer> intList = Stream
			.iterate(1, n -> n < 20, n -> n * 2)
			.toList();
		System.out.println(intList.getClass().getSimpleName() + " --- " + intList);

		intList = Stream
			.iterate(1, i -> i * 2)
			.skip(3)
			.limit(5)
			.toList();
		System.out.println(intList.getClass().getSimpleName() + " --- " + intList);

		intList = Stream
			.iterate(new int[]{0, 1}, n -> n[0] < 500, n -> new int[]{n[1], n[0] + n[1]})
			.map(n -> n[0])
			.toList();
		System.out.println(intList.getClass().getSimpleName() + " --- " + intList);

		Map<Integer, String> map = Stream
			.iterate(1, i -> i * 2)
			.skip(4)
			.limit(5)
			.collect(Collectors.toMap(Integer::intValue, i -> "\""+ i +"\""));
		System.out.println(map.getClass().getSimpleName() + " --- " + map);
	}
}
